package reichert._02_bildbearbeitung;

import processing.core.PApplet;
import processing.core.PImage;

public class BildbearbeitungVertikalSpiegeln extends PApplet {

	private static final long serialVersionUID = 1L;

	PImage original;
	PImage bearbeitet;

	public void setup() {
		original = loadImage("goldengate.jpg");
		original.loadPixels();

		bearbeitet = new PImage(original.width, original.height);
		bearbeitet.loadPixels();

		for (int bearbeitetY = 0; bearbeitetY < bearbeitet.height; bearbeitetY++) {
			for (int bearbeitetX = 0; bearbeitetX < bearbeitet.width; bearbeitetX++) {
				int originalX = bearbeitetX;
				int originalY = bearbeitet.height - 1 - bearbeitetY;
				int originalFarbe = getColor(original, originalX, originalY);

				setColor(bearbeitet, bearbeitetX, bearbeitetY, originalFarbe);
			}
		}
		bearbeitet.updatePixels();

		size(original.width * 2, original.height);
	}

	/**
	 * Liefert die Farbe des Pixels an Koordinate (x,y) in Bild image
	 */
	int getColor(PImage image, int x, int y) {
		return image.pixels[y * image.width + x];
	}

	/**
	 * Setzt die Farbe des Pixels an Koordinate (x,y) in Bild image auf color
	 */
	void setColor(PImage image, int x, int y, int color) {
		image.pixels[y * image.width + x] = color;
	}

	public void draw() {
		image(original, 0, 0, original.width, original.height);
		image(bearbeitet, original.width, 0, bearbeitet.width, bearbeitet.height);

	}

}
